/* 
	----------- SCLA Team ----------------
				LAPG data struct header
	--------------------------------------
	            		2007.06.02 by hopesjs 
 */

#ifndef LAPG_DATASTRUCT_H
#define LAPG_DATASTRUCT_H

// ø    
#include <termios.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>            // write(), read() ϴ   
#include <sys/signal.h>

//    
#define LAPG_RESET_CONFIGRATION      0
#define LAPG_RESET_DCLK      1
#define LAPG_RESET_EDGE      2
#define LAPG_RESET_EXE_MODE      3
#define LAPG_RESET_PROPAGATION_DELAY      4
#define LAPG_RESET_RESET      5

//    
#define LAPG_EXECUTE_INJECTION      0
#define LAPG_EXECUTE_SAMPLING      1
#define LAPG_EXECUTE_CNT_BASE      2
#define LAPG_EXECUTE_COUNT      3
#define LAPG_EXECUTE_RESET      5

// ڷ  3    
extern unsigned char lapg_reset_command;
extern unsigned char lapg_exe_command;
extern unsigned int lapg_send_data_bits_size;							//    ο 
extern unsigned char* lapg_send_data_field;								//    
extern unsigned int lapg_receive_data_bits_size;							//  ޴  ο 
extern unsigned char* lapg_receive_data_field;								//  ޴  

extern int fd_UART;
extern struct termios tio_UART;


// ¸  Ʈ Ѵ.
// mode : ٲ  (define ) , value :  ( 庰 ũ⿡ ° )
void set_reset_command(int mode, unsigned char value);
// ¸  Ʈ Ѵ.
// mode :  (define )
unsigned char read_reset_command(int mode);

//   Ʈ Ѵ.
// mode : ٲ  (define ) , value :  ( 庰 ũ⿡ ° )
void set_exe_command(int mode, unsigned char value);
//   Ʈ Ѵ.
// mode :  (define )
unsigned char read_exe_command(int mode);

// bitŭ  ʵ带 ޸ ҴѴ.
void malloc_data_field(unsigned int send_bits, unsigned int receive_bits);
//  ʵ带 ޸ Ѵ.
void free_data_field();
//   ʵ x ġ  value(bit) Ѵ.
void set_send_data_field(unsigned int bit_position, unsigned char value);
//   ʵ x ġ bit о´.
unsigned char read_send_data_field(unsigned int bit_position);
// ޴  ʵ x ġ  value(bit) Ѵ.
void set_receive_data_field(unsigned int bit_position, unsigned char value);
// ޴  ʵ x ġ bit о´.
unsigned char read_receive_data_field(unsigned int bit_position);

// ø   Լ
void UART_Open(char *device_uart);
void UART_Close(void);
int UART_send_reset_command(void);
int UART_send_execute_command(void);
void UART_data_field(void);
void UART_print_lapg_struct(void);
int UART_get_lapg_bits_size(void);
int UART_single_run(void);
//int UART_burst_run(void);

#endif
